;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module main
	.optsdcc -mstm8
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _tim2_isr
	.globl _main
	.globl _periodic_flag
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area INITIALIZED
_periodic_flag::
	.ds 1
;--------------------------------------------------------
; Stack segment in internal ram 
;--------------------------------------------------------
	.area	SSEG
__start__stack:
	.ds	1

;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area DABS (ABS)

; default segment ordering for linker
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area CONST
	.area INITIALIZER
	.area CODE

;--------------------------------------------------------
; interrupt vector 
;--------------------------------------------------------
	.area HOME
__interrupt_vect:
	int s_GSINIT ; reset
	int 0x000000 ; trap
	int 0x000000 ; int0
	int 0x000000 ; int1
	int 0x000000 ; int2
	int 0x000000 ; int3
	int 0x000000 ; int4
	int 0x000000 ; int5
	int 0x000000 ; int6
	int 0x000000 ; int7
	int 0x000000 ; int8
	int 0x000000 ; int9
	int 0x000000 ; int10
	int 0x000000 ; int11
	int 0x000000 ; int12
	int _tim2_isr ; int13
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area GSINIT
__sdcc_gs_init_startup:
__sdcc_init_data:
; stm8_genXINIT() start
	ldw x, #l_DATA
	jreq	00002$
00001$:
	clr (s_DATA - 1, x)
	decw x
	jrne	00001$
00002$:
	ldw	x, #l_INITIALIZER
	jreq	00004$
00003$:
	ld	a, (s_INITIALIZER - 1, x)
	ld	(s_INITIALIZED - 1, x), a
	decw	x
	jrne	00003$
00004$:
; stm8_genXINIT() end
	.area GSFINAL
	jp	__sdcc_program_startup
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME
	.area HOME
__sdcc_program_startup:
	jp	_main
;	return from main will return to caller
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CODE
;	main.c: 31: static void wait_us(uint16_t time)
;	-----------------------------------------
;	 function wait_us
;	-----------------------------------------
_wait_us:
;	main.c: 33: TIM1->ARRH.reg = (time >> 8) & 0xff; // set timeout
	ld	a, (0x03, sp)
	ld	0x5262, a
;	main.c: 34: TIM1->ARRL.reg = (time >> 0) & 0xff; // set timeout
	ld	a, (0x04, sp)
	ld	0x5263, a
;	main.c: 35: TIM1->CR1.fields.CEN = 1; // enable timer
	ldw	x, #0x5250
	ld	a, (x)
	or	a, #0x01
	ld	(x), a
;	main.c: 36: while (TIM1->CR1.fields.CEN); // wait until time passed
00101$:
	ldw	x, #0x5250
	ld	a, (x)
	and	a, #0x01
	jrne	00101$
;	main.c: 37: }
	ret
;	main.c: 40: static void send_bit(bool bit)
;	-----------------------------------------
;	 function send_bit
;	-----------------------------------------
_send_bit:
;	main.c: 43: DEHUMIDIFIER_PORT->ODR.reg &= ~DEHUMIDIFIER_PIN; // set low
	bres	20495, #2
;	main.c: 44: wait_us(500 - 5); // time with function call delay
	push	#0xef
	push	#0x01
	call	_wait_us
	popw	x
;	main.c: 46: DEHUMIDIFIER_PORT->ODR.reg |= DEHUMIDIFIER_PIN; // set high
	bset	20495, #2
;	main.c: 47: if (bit) {
	tnz	(0x03, sp)
	jreq	00102$
;	main.c: 48: wait_us(1500 - 7); // long high pulse
	push	#0xd5
	push	#0x05
	call	_wait_us
	popw	x
	ret
00102$:
;	main.c: 50: wait_us(500 - 5); // short high pulse
	push	#0xef
	push	#0x01
	call	_wait_us
	popw	x
;	main.c: 52: }
	ret
;	main.c: 55: static void send_byte(uint8_t byte)
;	-----------------------------------------
;	 function send_byte
;	-----------------------------------------
_send_byte:
	push	a
;	main.c: 57: for (int8_t i = 7; i >= 0; i--) {
	ld	a, #0x07
	ld	(0x01, sp), a
00103$:
	tnz	(0x01, sp)
	jrmi	00105$
;	main.c: 58: send_bit((byte >> i) & 0x01);
	ld	a, (0x04, sp)
	push	a
	ld	a, (0x02, sp)
	jreq	00120$
00119$:
	srl	(1, sp)
	dec	a
	jrne	00119$
00120$:
	pop	a
	and	a, #0x01
	push	a
	call	_send_bit
	pop	a
;	main.c: 57: for (int8_t i = 7; i >= 0; i--) {
	dec	(0x01, sp)
	jra	00103$
00105$:
;	main.c: 60: }
	pop	a
	ret
;	main.c: 63: static void send_break(void)
;	-----------------------------------------
;	 function send_break
;	-----------------------------------------
_send_break:
;	main.c: 66: DEHUMIDIFIER_PORT->ODR.reg &= ~DEHUMIDIFIER_PIN; // set low
	bres	20495, #2
;	main.c: 67: wait_us(12250 - 759); // long low pulse
	push	#0xe3
	push	#0x2c
	call	_wait_us
	popw	x
;	main.c: 68: DEHUMIDIFIER_PORT->ODR.reg |= DEHUMIDIFIER_PIN; // set high
	bset	20495, #2
;	main.c: 69: }
	ret
;	main.c: 71: static uint8_t i2c_transmit(uint8_t addr, const uint8_t* data, uint8_t len)
;	-----------------------------------------
;	 function i2c_transmit
;	-----------------------------------------
_i2c_transmit:
	push	a
;	main.c: 73: if (0 == len || 0 == data) {
	tnz	(0x07, sp)
	jreq	00101$
	ldw	x, (0x05, sp)
	jrne	00102$
00101$:
;	main.c: 74: return 0;
	clr	a
	jp	00148$
00102$:
;	main.c: 76: I2C_SR2 = 0; // clear errors
	mov	0x5218+0, #0x00
;	main.c: 77: I2C_CR2 |= I2C_CR2_START; // send start condition
	bset	21009, #0
;	main.c: 78: while (!(I2C_SR1 & I2C_SR1_SB)) { // wait until start bit is sent
00106$:
	ld	a, 0x5217
	srl	a
	jrc	00108$
;	main.c: 79: if (I2C_SR2 & (I2C_SR2_ARLO | I2C_SR2_BERR)) { // bus error occurred
	ld	a, 0x5218
	bcp	a, #0x03
	jreq	00106$
;	main.c: 80: return 1;
	ld	a, #0x01
	jp	00148$
00108$:
;	main.c: 83: if (!(I2C_SR3 & I2C_SR3_MSL)) { // ensure we are in master mode
	ld	a, 0x5219
	srl	a
	jrc	00110$
;	main.c: 84: return 2;
	ld	a, #0x02
	jp	00148$
00110$:
;	main.c: 86: I2C_SR2 = 0; // clear errors
	mov	0x5218+0, #0x00
;	main.c: 87: I2C_DR = (addr << 1) | 0; // select device in transmit
	ld	a, (0x04, sp)
	sll	a
	ld	0x5216, a
;	main.c: 88: while (!(I2C_SR1 & I2C_SR1_ADDR)) { // wait until address has been transmitted
00113$:
	ld	a, 0x5217
	ld	xl, a
;	main.c: 79: if (I2C_SR2 & (I2C_SR2_ARLO | I2C_SR2_BERR)) { // bus error occurred
	ld	a, 0x5218
;	main.c: 88: while (!(I2C_SR1 & I2C_SR1_ADDR)) { // wait until address has been transmitted
	push	a
	ld	a, xl
	bcp	a, #0x02
	pop	a
	jrne	00115$
;	main.c: 89: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	srl	a
	jrnc	00113$
;	main.c: 90: return 3;
	ld	a, #0x03
	jp	00148$
00115$:
;	main.c: 93: if (I2C_SR2 & I2C_SR2_AF) { // no ACK received
	bcp	a, #0x04
	jreq	00117$
;	main.c: 94: return 4;
	ld	a, #0x04
	jra	00148$
00117$:
;	main.c: 96: if (!(I2C_SR3 & I2C_SR3_TRA)) { // ensure we are in transmit mode
	ld	a, 0x5219
	bcp	a, #0x04
	jrne	00164$
;	main.c: 97: return 5;
	ld	a, #0x05
	jra	00148$
;	main.c: 99: for (uint8_t i = 0; i < len; i++) {
00164$:
	clr	(0x01, sp)
00146$:
	ld	a, (0x01, sp)
	cp	a, (0x07, sp)
	jrnc	00130$
;	main.c: 100: while (!(I2C_SR1 & I2C_SR1_TXE)) { // wait until transmit register is empty
00122$:
	ld	a, 0x5217
	ld	xh, a
;	main.c: 79: if (I2C_SR2 & (I2C_SR2_ARLO | I2C_SR2_BERR)) { // bus error occurred
	ld	a, 0x5218
;	main.c: 100: while (!(I2C_SR1 & I2C_SR1_TXE)) { // wait until transmit register is empty
	tnzw	x
	jrmi	00124$
;	main.c: 101: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	srl	a
	jrnc	00122$
;	main.c: 102: return 6;
	ld	a, #0x06
	jra	00148$
00124$:
;	main.c: 105: if (I2C_SR2 & I2C_SR2_AF) { // no ACK received
	bcp	a, #0x04
	jreq	00126$
;	main.c: 106: return 7;
	ld	a, #0x07
	jra	00148$
00126$:
;	main.c: 108: I2C_DR = data[i]; // send data byte
	clrw	x
	ld	a, (0x01, sp)
	ld	xl, a
	addw	x, (0x05, sp)
	ld	a, (x)
	ld	0x5216, a
;	main.c: 99: for (uint8_t i = 0; i < len; i++) {
	inc	(0x01, sp)
	jra	00146$
;	main.c: 110: while (!(I2C_SR1 & I2C_SR1_TXE)) { // wait until transmit register is empty
00130$:
	ld	a, 0x5217
	jrmi	00135$
;	main.c: 111: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	ld	a, 0x5218
	srl	a
	jrnc	00130$
;	main.c: 112: return 8;
	ld	a, #0x08
	jra	00148$
;	main.c: 115: while (!(I2C_SR1 & I2C_SR1_BTF)) { // wait until transmission completed
00135$:
	ld	a, 0x5217
	bcp	a, #0x04
	jrne	00137$
;	main.c: 116: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	ld	a, 0x5218
	srl	a
	jrnc	00135$
;	main.c: 117: return 9;
	ld	a, #0x09
	jra	00148$
00137$:
;	main.c: 120: I2C_CR2 |= I2C_CR2_STOP; // send stop
	bset	21009, #1
;	main.c: 121: while (I2C_SR3 & I2C_SR3_BUSY) { // wait until transmission ended
00140$:
	ld	a, 0x5219
	bcp	a, #0x02
	jreq	00142$
;	main.c: 122: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	ld	a, 0x5218
	srl	a
	jrnc	00140$
;	main.c: 123: return 10;
	ld	a, #0x0a
	jra	00148$
00142$:
;	main.c: 126: if (I2C_SR3 & I2C_SR3_MSL) { // ensure we are back in slave mode
	ld	a, 0x5219
	srl	a
	jrnc	00144$
;	main.c: 127: return 11;
	ld	a, #0x0b
;	main.c: 129: return 0;
	.byte 0x21
00144$:
	clr	a
00148$:
;	main.c: 130: }
	addw	sp, #1
	ret
;	main.c: 132: static uint8_t i2c_receive(uint8_t addr, uint8_t* data, uint8_t len)
;	-----------------------------------------
;	 function i2c_receive
;	-----------------------------------------
_i2c_receive:
	sub	sp, #3
;	main.c: 134: if (0 == len || 0 == data) {
	tnz	(0x09, sp)
	jreq	00101$
	ldw	x, (0x07, sp)
	jrne	00102$
00101$:
;	main.c: 135: return 0;
	clr	a
	jp	00154$
00102$:
;	main.c: 137: I2C_SR2 = 0; // clear errors
	mov	0x5218+0, #0x00
;	main.c: 138: I2C_CR2 |= I2C_CR2_START; // send start condition
	bset	21009, #0
;	main.c: 139: while (!(I2C_SR1 & I2C_SR1_SB)) { // wait until start bit is sent
00106$:
	ld	a, 0x5217
	srl	a
	jrc	00108$
;	main.c: 140: if (I2C_SR2 & (I2C_SR2_ARLO | I2C_SR2_BERR)) { // bus error occurred
	ld	a, 0x5218
	bcp	a, #0x03
	jreq	00106$
;	main.c: 141: return 1;
	ld	a, #0x01
	jp	00154$
00108$:
;	main.c: 144: if (!(I2C_SR3 & I2C_SR3_MSL)) { // ensure we are in master mode
	ld	a, 0x5219
	srl	a
	jrc	00110$
;	main.c: 145: return 2;
	ld	a, #0x02
	jp	00154$
00110$:
;	main.c: 147: I2C_SR2 = 0; // clear errors
	mov	0x5218+0, #0x00
;	main.c: 148: I2C_DR = (addr << 1) | 1; // select device in receive
	ld	a, (0x06, sp)
	sll	a
	or	a, #0x01
	ld	0x5216, a
;	main.c: 149: while (!(I2C_SR1 & I2C_SR1_ADDR)) { // wait until address has been transmitted
00113$:
	ld	a, 0x5217
	ld	xl, a
;	main.c: 140: if (I2C_SR2 & (I2C_SR2_ARLO | I2C_SR2_BERR)) { // bus error occurred
	ld	a, 0x5218
;	main.c: 149: while (!(I2C_SR1 & I2C_SR1_ADDR)) { // wait until address has been transmitted
	push	a
	ld	a, xl
	bcp	a, #0x02
	pop	a
	jrne	00115$
;	main.c: 150: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	srl	a
	jrnc	00113$
;	main.c: 151: return 3;
	ld	a, #0x03
	jp	00154$
00115$:
;	main.c: 154: if (I2C_SR2 & I2C_SR2_AF) { // no ACK received
	bcp	a, #0x04
	jreq	00117$
;	main.c: 155: return 4;
	ld	a, #0x04
	jp	00154$
00117$:
;	main.c: 157: if (I2C_SR3 & I2C_SR3_TRA) { // ensure we are in receive mode
	ld	a, 0x5219
	bcp	a, #0x04
	jreq	00119$
;	main.c: 158: return 5;
	ld	a, #0x05
	jp	00154$
00119$:
;	main.c: 160: data[0] = I2C_DR; // just to clear the flag
	ldw	y, (0x07, sp)
	ld	a, 0x5216
	ld	(y), a
;	main.c: 138: I2C_CR2 |= I2C_CR2_START; // send start condition
	ld	a, 0x5211
;	main.c: 162: I2C_CR2 &= ~I2C_CR2_ACK; // already send NACK
	ld	xl, a
	and	a, #0xfb
;	main.c: 161: if (1 == len) {
	push	a
	ld	a, (0x0a, sp)
	dec	a
	pop	a
	jrne	00142$
;	main.c: 162: I2C_CR2 &= ~I2C_CR2_ACK; // already send NACK
	ld	0x5211, a
;	main.c: 163: I2C_CR2 |= I2C_CR2_STOP; // already program stop
	bset	21009, #1
;	main.c: 164: while (!(I2C_SR1 & I2C_SR1_RXNE)) { // wait to receive data
00122$:
	ld	a, 0x5217
	bcp	a, #0x40
	jrne	00124$
;	main.c: 165: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	ld	a, 0x5218
	srl	a
	jrnc	00122$
;	main.c: 166: return 6;
	ld	a, #0x06
	jp	00154$
00124$:
;	main.c: 169: data[0] = I2C_DR; // save receive data
	ld	a, 0x5216
	ld	(y), a
	jra	00146$
00142$:
;	main.c: 170: } else if (2 == len) {
	push	a
	ld	a, (0x0a, sp)
	cp	a, #0x02
	pop	a
	jrne	00139$
;	main.c: 171: I2C_CR2 &= ~I2C_CR2_ACK; // already send NACK
	ld	0x5211, a
;	main.c: 172: while (!(I2C_SR1 & I2C_SR1_BTF)) { // wait until 2 bytes received
00127$:
	ld	a, 0x5217
	bcp	a, #0x04
	jrne	00129$
;	main.c: 173: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	ld	a, 0x5218
	srl	a
	jrnc	00127$
;	main.c: 174: return 7;
	ld	a, #0x07
	jra	00154$
00129$:
;	main.c: 177: I2C_CR2 |= I2C_CR2_STOP; // send stop
	bset	21009, #1
	jra	00146$
00139$:
;	main.c: 179: I2C_CR2 |= I2C_CR2_ACK; // send ACK
	ld	a, xl
	or	a, #0x04
	ld	0x5211, a
;	main.c: 180: for (uint8_t i = 0; i < len; i++) {
	clr	(0x03, sp)
00152$:
	ld	a, (0x03, sp)
	cp	a, (0x09, sp)
	jrnc	00146$
;	main.c: 181: while (!(I2C_SR1 & I2C_SR1_RXNE)) { // wait to receive data
00132$:
	ld	a, 0x5217
	bcp	a, #0x40
	jrne	00134$
;	main.c: 182: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	ld	a, 0x5218
	srl	a
	jrnc	00132$
;	main.c: 183: return 8;
	ld	a, #0x08
	jra	00154$
00134$:
;	main.c: 186: data[i] = I2C_DR; // save receive data
	ld	a, yl
	add	a, (0x03, sp)
	ld	xl, a
	ld	a, yh
	adc	a, #0x00
	ld	xh, a
	ld	a, 0x5216
	ld	(x), a
;	main.c: 187: if (i + 1 == len) {
	clrw	x
	ld	a, (0x03, sp)
	ld	xl, a
	incw	x
	ldw	(0x01, sp), x
	ld	a, (0x09, sp)
	clrw	x
	ld	xl, a
	cpw	x, (0x01, sp)
	jrne	00153$
;	main.c: 188: I2C_CR2 &= ~I2C_CR2_ACK; // send NACK
	bres	21009, #2
;	main.c: 189: I2C_CR2 |= I2C_CR2_STOP; // send stop
	bset	21009, #1
00153$:
;	main.c: 180: for (uint8_t i = 0; i < len; i++) {
	inc	(0x03, sp)
	jra	00152$
;	main.c: 193: while (I2C_SR3 & I2C_SR3_BUSY) { // wait until transmission ended
00146$:
	ld	a, 0x5219
	bcp	a, #0x02
	jreq	00148$
;	main.c: 194: if (I2C_SR2 & I2C_SR2_BERR) { // bus error occurred
	ld	a, 0x5218
	srl	a
	jrnc	00146$
;	main.c: 195: return 10;
	ld	a, #0x0a
	jra	00154$
00148$:
;	main.c: 198: if (I2C_SR3 & I2C_SR3_MSL) { // ensure we are back in slave mode
	ld	a, 0x5219
	srl	a
	jrnc	00150$
;	main.c: 199: return 11;
	ld	a, #0x0b
;	main.c: 202: return 0;
	.byte 0x21
00150$:
	clr	a
00154$:
;	main.c: 203: }
	addw	sp, #3
	ret
;	main.c: 205: void main(void)
;	-----------------------------------------
;	 function main
;	-----------------------------------------
_main:
	sub	sp, #15
;	main.c: 207: sim(); // disable interrupts (while we reconfigure them)
	sim
;	main.c: 209: CLK->CKDIVR.fields.HSIDIV = CLK_CKDIVR_HSIDIV_DIV0; // don't divide internal 16 MHz clock
	ldw	x, #0x50c6
	ld	a, #0xe7
	and	a, (x)
	ld	(x), a
;	main.c: 210: CLK->CKDIVR.fields.CPUDIV = CLK_CKDIVR_CPUDIV_DIV0; // don't divide CPU frequency to 16 MHz
	ldw	x, #0x50c6
	ld	a, #0xf8
	and	a, (x)
	ld	(x), a
;	main.c: 211: while (!CLK->ICKR.fields.HSIRDY); // wait for internal oscillator to be ready
00101$:
	ldw	x, #0x50c0
	ld	a, (x)
	srl	a
	and	a, #0x01
	jreq	00101$
;	main.c: 214: DEHUMIDIFIER_PORT->DDR.reg |= DEHUMIDIFIER_PIN; // switch pin to output
	bset	20497, #2
;	main.c: 215: DEHUMIDIFIER_PORT->CR1.reg &= ~DEHUMIDIFIER_PIN; // switch output to open-drain
	bres	20498, #2
;	main.c: 217: DEHUMIDIFIER_PORT->ODR.reg |= DEHUMIDIFIER_PIN; // set idle high
	bset	20495, #2
;	main.c: 220: CLK_PCKENR1 |= CLK_PCKENR1_I2C; // enable I²C peripheral (should be on per default)
	bset	20679, #0
;	main.c: 221: GPIO_PB->CR1.reg |= (PB4 | PB5); // enable internal pull-up on SCL/SDA (there should also be external pull-up resistors)
	ld	a, 0x5008
	or	a, #0x30
	ld	0x5008, a
;	main.c: 222: GPIO_PB->DDR.reg &= ~(PB4 | PB5); // set SCL/SDA as input before it is used as alternate function by the peripheral
	ld	a, 0x5007
	and	a, #0xcf
	ld	0x5007, a
;	main.c: 223: I2C_CR1 |= I2C_CR1_PE; // enable I²C peripheral (must be done before any other register is written)
	bset	21008, #0
;	main.c: 224: I2C_CR2 |= I2C_CR2_STOP; // release lines
	bset	21009, #1
;	main.c: 225: I2C_CR2 |= I2C_CR2_SWRST; // reset peripheral, in case we got stuck and the dog bit
	bset	21009, #7
;	main.c: 226: while (!(GPIO_PB->IDR.reg & PB4)); // wait for SCL line to be released
00104$:
	ld	a, 0x5006
	bcp	a, #0x10
	jreq	00104$
;	main.c: 227: while (!(GPIO_PB->IDR.reg & PB5)); // wait for SDA line to be released
00107$:
	ld	a, 0x5006
	bcp	a, #0x20
	jreq	00107$
;	main.c: 228: I2C_CR2 &= ~I2C_CR2_SWRST; // release reset
	bres	21009, #7
;	main.c: 229: I2C_CR1 &= ~I2C_CR1_PE; // disable I²C peripheral to configure it
	bres	21008, #0
;	main.c: 230: I2C_FREQR = 16; // the peripheral frequency is 16 MHz (must match CPU frequency)
	mov	0x5212+0, #0x10
;	main.c: 231: I2C_CCRH = (uint8_t)(8000 >> 8); // set control clock to 100 kHz (16 MHz / 2 * 8000), standard mode
	mov	0x521c+0, #0x1f
;	main.c: 232: I2C_CCRL = (uint8_t)(8000 >> 0); // set control clock to 100 kHz (16 MHz / 2 * 8000)
	mov	0x521b+0, #0x40
;	main.c: 233: I2C_TRISER = 0x09; // set maximum rise time for SCL (100 ns in standard mode)
	mov	0x521d+0, #0x09
;	main.c: 234: I2C_CR1 |= I2C_CR1_PE; // re-enable I²C peripheral
	bset	21008, #0
;	main.c: 237: TIM2->CR1.fields.URS = 1; // only interrupt on overflow
	clrw	x
	ld	a, #0x53
	ld	xh, a
	ld	a, (x)
	or	a, #0x04
	ld	(x), a
;	main.c: 238: TIM2->PSCR.fields.PSC = 6; // best prescaler for most precise timer for up to 0.262 second (1.0/(16E6/(2**6)) * 2**16)
	ldw	x, #0x530e
	ld	a, #0xf0
	and	a, (x)
	or	a, #0x06
	ld	(x), a
;	main.c: 239: TIM2->ARRH.reg = 62500 >> 8; // set the timeout to 250 ms
	mov	0x530f+0, #0xf4
;	main.c: 240: TIM2->ARRL.reg = 62500 & 0xff; // set the timeout to 250 ms
	mov	0x5310+0, #0x24
;	main.c: 241: TIM2->IER.fields.UIE = 1; // enable update/overflow interrupt
	ldw	x, #0x5303
	ld	a, (x)
	or	a, #0x01
	ld	(x), a
;	main.c: 242: TIM2->CR1.fields.CEN = 1; // enable timer for periodic value output
	clrw	x
	ld	a, #0x53
	ld	xh, a
	ld	a, (x)
	or	a, #0x01
	ld	(x), a
;	main.c: 245: TIM1->CR1.fields.OPM = 1; // only run once
	ldw	x, #0x5250
	ld	a, (x)
	or	a, #0x08
	ld	(x), a
;	main.c: 246: TIM1->CR1.fields.URS = 1; // only interrupt on overflow
	ldw	x, #0x5250
	ld	a, (x)
	or	a, #0x04
	ld	(x), a
;	main.c: 247: TIM1->PSCRH.reg = ((16 - 1) >> 8); // set prescaler to have us
	mov	0x5260+0, #0x00
;	main.c: 248: TIM1->PSCRL.reg = ((16 - 1) >> 0); // set prescaler to have us
	mov	0x5261+0, #0x0f
;	main.c: 249: TIM1->CNTRH.reg = 0; // reset counter value (should be per default)
	mov	0x525e+0, #0x00
;	main.c: 250: TIM1->CNTRL.reg = 0; // reset counter value (should be per default)
	mov	0x525f+0, #0x00
;	main.c: 251: wait_us(2); // test it once
	push	#0x02
	push	#0x00
	call	_wait_us
	popw	x
;	main.c: 254: IWDG->KR.fields.KEY = IWDG_KR_KEY_REFRESH; // reset watchdog
	ldw	x, #0x50e0
	ld	a, #0xaa
	ld	(x), a
;	main.c: 255: IWDG->KR.fields.KEY = IWDG_KR_KEY_ENABLE; // start watchdog
	ldw	x, #0x50e0
	ld	a, #0xcc
	ld	(x), a
;	main.c: 256: IWDG->KR.fields.KEY = IWDG_KR_KEY_ACCESS; // allows changing the prescale
	ldw	x, #0x50e0
	ld	a, #0x55
	ld	(x), a
;	main.c: 257: IWDG->PR.fields.PR = IWDG_PR_DIV256; // set prescale to longest time (1.02s)
	ldw	x, #0x50e1
	ld	a, #0xf8
	and	a, (x)
	or	a, #0x06
	ld	(x), a
;	main.c: 258: IWDG->KR.fields.KEY = IWDG_KR_KEY_REFRESH; // reset watchdog
	ldw	x, #0x50e0
	ld	a, #0xaa
	ld	(x), a
;	main.c: 260: rim(); // re-enable interrupts
	rim
;	main.c: 261: bool action = false; // if an action has been performed
	clr	(0x0c, sp)
;	main.c: 264: wait_us(40000); // wait 40 ms for device to start up
	push	#0x40
	push	#0x9c
	call	_wait_us
	popw	x
;	main.c: 265: const uint8_t aht20_reset[] = {AHT20_CMD_RESET};
	ldw	x, sp
	incw	x
	ld	a, #0xba
	ld	(x), a
;	main.c: 266: uint8_t rc = i2c_transmit(SENSOR_ADDR, aht20_reset, ARRAY_LENGTH(aht20_reset)); // send software reset
	push	#0x01
	pushw	x
	push	#0x38
	call	_i2c_transmit
	addw	sp, #4
;	main.c: 267: if (rc) {
	tnz	a
	jreq	00114$
;	main.c: 268: while(true); // let the dog bite
00111$:
	jra	00111$
00114$:
;	main.c: 270: wait_us(20000); // wait 20 ms for reset to complete
	push	#0x20
	push	#0x4e
	call	_wait_us
	popw	x
;	main.c: 272: rc = i2c_receive(SENSOR_ADDR, rx_buffer, 1); // read the status
	push	#0x01
	ldw	x, sp
	addw	x, #3
	pushw	x
	push	#0x38
	call	_i2c_receive
	addw	sp, #4
;	main.c: 273: if (rc) {
	tnz	a
	jreq	00119$
;	main.c: 274: while(true); // let the dog bite
00116$:
	jra	00116$
00119$:
;	main.c: 276: if (!(rx_buffer[0] & 0x08)) { // ensure it is calibrated
	ld	a, (0x02, sp)
	bcp	a, #0x08
	jrne	00126$
;	main.c: 277: const uint8_t aht20_init[] = {AHT20_CMD_INIT};
	ld	a, #0xbe
	ld	(0x0b, sp), a
;	main.c: 278: rc = i2c_transmit(SENSOR_ADDR, aht20_init, ARRAY_LENGTH(aht20_init)); // initialise device (not sure what it does)
	push	#0x01
	ldw	x, sp
	addw	x, #12
	pushw	x
	push	#0x38
	call	_i2c_transmit
	addw	sp, #4
;	main.c: 279: if (rc) {
	tnz	a
	jreq	00124$
;	main.c: 280: while(true); // let the dog bite
00121$:
	jra	00121$
00124$:
;	main.c: 282: wait_us(10000); // wait 10 ms for calibration to complete
	push	#0x10
	push	#0x27
	call	_wait_us
	popw	x
00126$:
;	main.c: 285: const uint8_t aht20_trigger[] = {AHT20_CMD_TRIGGER, 0x33, 0x00};
	ld	a, #0xac
	ld	(0x09, sp), a
	ldw	x, sp
	ld	a, #0x33
	ld	(10, x), a
	ldw	x, sp
	clr	(11, x)
;	main.c: 286: rc = i2c_transmit(SENSOR_ADDR, aht20_trigger, ARRAY_LENGTH(aht20_trigger));
	push	#0x03
	ldw	x, sp
	addw	x, #10
	pushw	x
	push	#0x38
	call	_i2c_transmit
	addw	sp, #4
;	main.c: 287: if (rc) {
	tnz	a
	jreq	00131$
;	main.c: 288: while(true); // let the dog bite
00128$:
	jra	00128$
00131$:
;	main.c: 290: wait_us(80000); // wait 80 ms for measurement to complete
	push	#0x80
	push	#0x38
	call	_wait_us
	popw	x
;	main.c: 292: uint8_t humidity = 99;
	ld	a, #0x63
	ld	(0x0d, sp), a
;	main.c: 293: uint8_t temp = 0;
	clr	(0x0f, sp)
;	main.c: 294: while (true) {
00150$:
;	main.c: 295: IWDG_KR = IWDG_KR_KEY_REFRESH; // reset watchdog
	mov	0x50e0+0, #0xaa
;	main.c: 296: if (periodic_flag) { // time to get and send measurements
	btjt	_periodic_flag+0, #0, 00243$
	jp	00145$
00243$:
;	main.c: 297: periodic_flag = false; // clear flag
	clr	_periodic_flag+0
;	main.c: 298: rc = i2c_receive(SENSOR_ADDR, rx_buffer, ARRAY_LENGTH(rx_buffer)); // read measurement
	push	#0x07
	ldw	x, sp
	addw	x, #3
	pushw	x
	push	#0x38
	call	_i2c_receive
	addw	sp, #4
;	main.c: 299: if (rc) {
	tnz	a
	jreq	00136$
;	main.c: 300: while(true); // let the dog bite
00133$:
	jra	00133$
00136$:
;	main.c: 302: if (!(rx_buffer[0] & 0x80)) { // not busy doing the measurement
	ld	a, (0x02, sp)
	jrmi	00143$
;	main.c: 303: humidity = (rx_buffer[1] * (uint16_t)100) / 256; // save new humidity value, only use the 8 MSb out of 20
	ld	a, (0x03, sp)
	clrw	x
	ld	xl, a
	pushw	x
	push	#0x64
	push	#0x00
	call	__mulint
	addw	sp, #4
	ld	a, xh
	ld	(0x0d, sp), a
;	main.c: 304: temp = (((uint8_t)(rx_buffer[3] << 4) + (uint8_t)(rx_buffer[4] >> 4)) * (uint16_t)200) / 256 - 50; // save new temperature, only use the 8 MSB (out of 20)
	ld	a, (0x05, sp)
	swap	a
	and	a, #0xf0
	clrw	x
	ld	xl, a
	ld	a, (0x06, sp)
	swap	a
	and	a, #0x0f
	ld	(0x0f, sp), a
	clr	(0x0e, sp)
	addw	x, (0x0e, sp)
	pushw	x
	push	#0xc8
	push	#0x00
	call	__mulint
	addw	sp, #4
	ld	a, xh
	sub	a, #0x32
	ld	(0x0f, sp), a
;	main.c: 306: rc = i2c_transmit(SENSOR_ADDR, aht20_trigger, ARRAY_LENGTH(aht20_trigger));
	push	#0x03
	ldw	x, sp
	addw	x, #10
	pushw	x
	push	#0x38
	call	_i2c_transmit
	addw	sp, #4
;	main.c: 307: if (rc) {
	tnz	a
	jreq	00143$
;	main.c: 308: while(true); // let the dog bite
00138$:
	jra	00138$
00143$:
;	main.c: 311: send_byte(temp);
	ld	a, (0x0f, sp)
	push	a
	call	_send_byte
	pop	a
;	main.c: 312: send_byte(humidity);
	ld	a, (0x0d, sp)
	push	a
	call	_send_byte
	pop	a
;	main.c: 313: send_byte(temp ^ 0xff);
	ld	a, (0x0f, sp)
	cpl	a
	push	a
	call	_send_byte
	pop	a
;	main.c: 314: send_byte(humidity ^ 0xff);
	ld	a, (0x0d, sp)
	clrw	x
	cpl	a
	push	a
	call	_send_byte
	pop	a
;	main.c: 315: send_break();
	call	_send_break
00145$:
;	main.c: 317: if (action) { // something has been performed, check if other flags have been set meanwhile
	tnz	(0x0c, sp)
	jreq	00147$
;	main.c: 318: action = false; // clear flag
	clr	(0x0c, sp)
	jp	00150$
00147$:
;	main.c: 320: wfi(); // go to sleep (wait for periodic ping)
	wfi
;	main.c: 323: }
	jp	00150$
;	main.c: 325: void tim2_isr(void) __interrupt(IRQ_TIM2_UO) // timer 2 update interrupt service routine
;	-----------------------------------------
;	 function tim2_isr
;	-----------------------------------------
_tim2_isr:
;	main.c: 327: if (TIM2->SR1.fields.UIF) { // 250 ms passed, time to send data
	ldw	x, #0x5304
	ld	a, (x)
	and	a, #0x01
	jreq	00103$
;	main.c: 328: TIM2->SR1.fields.UIF = 0; // clear flag
	ldw	x, #0x5304
	ld	a, #0xfe
	and	a, (x)
	ld	(x), a
;	main.c: 329: periodic_flag = true; // notify main loop
	mov	_periodic_flag+0, #0x01
00103$:
;	main.c: 331: }
	iret
	.area CODE
	.area CONST
	.area INITIALIZER
__xinit__periodic_flag:
	.db #0x00	;  0
	.area CABS (ABS)
